/********************************************************************************
*                                                                               *
*                  Base class of an event driven FXStream                       *
*                                                                               *
*********************************************************************************
* Copyright (C) 2003 by Mathew Robertson.   All Rights Reserved.                *
*********************************************************************************
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    *
*********************************************************************************/
#include <config.h>
#include <fox/fxver.h>
#include <fox/xincs.h>
#include <fox/fxdefs.h>
#include <fox/FXStream.h>
#include <fox/FXString.h>
#include <fox/FXSize.h>
#include <fox/FXPoint.h>
#include <fox/FXRectangle.h>
#include <fox/FXRegistry.h>
#include <fox/FXApp.h>
using namespace FX;
#include "FXEventStream.h"
using namespace FXEX;
namespace FXEX {

// map
FXIMPLEMENT(FXEventStream,FXBaseObject,NULL,0)

// ctor
FXEventStream::FXEventStream(FXApp *a,FXObject *tgt,FXSelector sel,const FXObject *cont) : FXBaseObject(a,tgt,sel), FXStream(cont){
  }

// free up all resources
FXEventStream::~FXEventStream(){
  }

// signal target object if new data available
void FXEventStream::signal(void *ptr){
  if (target) target->handle(this,FXSEL(SEL_COMMAND,message),ptr);
  }

// signal target object if new data available, using a specific seltype
void FXEventStream::signal(FXuint seltype,void *ptr){
  if (target) target->handle(this,FXSEL(seltype,message),ptr);
  }

}

