/********************************************************************************
*                                                                               *
*               Null Mutex - can be used to test mutex handling                 *
*                                                                               *
*********************************************************************************
* Copyright (C) 2003 by Mathew Robertson.   All Rights Reserved.                *
*********************************************************************************
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    *
********************************************************************************/
#include <config.h>
#include <fox/fxdefs.h>
using namespace FX;
#include "FXNullMutex.h"
using namespace FXEX;
namespace FXEX {

// dtor
FXNullMutex::~FXNullMutex(){
  fxmessage("FXNullMutex: locks held: %i\n",lock_);
  }

// unlock
void FXNullMutex::unlock() {
  if (lock_==0) fxerror("FXNullMutex::unlock() called too many times\n");
  else lock_--;
  }

}

