/********************************************************************************
*                                                                               *
*                  Socket IO client                                             *
*                                                                               *
*********************************************************************************
* Copyright (C) 2003 by Mathew Robertson.   All Rights Reserved.                *
*********************************************************************************
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    *
*********************************************************************************/
#include <config.h>
#include <fox/fxver.h>
#include <fox/xincs.h>
#include <fox/fxdefs.h>
#include <fox/FXStream.h>
#include <fox/FXString.h>
#include <fox/FXSize.h>
#include <fox/FXPoint.h>
#include <fox/FXRectangle.h>
#include <fox/FXRegistry.h>
#include <fox/FXApp.h>
using namespace FX;
#include "exincs.h"
#include "fxexdefs.h"
#include "FXThreadEvent.h"
#include "FXFastMutex.h"
#include "FXAtomic.h"
#include "FXMutex.h"
#include "FXResolver.h"
#include "FXSocketClient.h"
using namespace FXEX;
namespace FXEX {

// map
FXIMPLEMENT(FXSocketClient,FXSocket,NULL,0)

// ctor
FXSocketClient::FXSocketClient(FXApp* a,const FXString &host,FXint port,FXObject *tgt,FXSelector sel,FXSocketFamily fmly,FXSocketType tpe) : FXSocket(a,port,tgt,sel,fmly,tpe) {hostname=host;}

// ctor
FXSocketClient::FXSocketClient(FXApp* a,const FXString &host,const FXString &service,FXObject *tgt,FXSelector sel,FXSocketFamily fmly,FXSocketType tpe) : FXSocket(a,service,tgt,sel,fmly,tpe) {hostname=host;}

// open out-bound connection
FXbool FXSocketClient::open(){
  if (status() != FXIOStatusOk || getState()!=FXIOStateNone || !hostname.length()) return FALSE;
  if (!FXSocket::open()) return FALSE;
  return connect(hostname);
  }

}
