// ------------------------------------------------- NEW CODE FOR REGIONS TESTING ---
  // four penguins as background
  FXGIFImage penguinImg(getApp(), bigpenguin, IMAGE_KEEP);
  penguinImg.create();
  penguinImg.scale(80, 100);
  dc.drawImage(&penguinImg, 0, 210);
  dc.drawImage(&penguinImg, 80, 210);
  dc.drawImage(&penguinImg, 450, 210);
  dc.drawImage(&penguinImg, 530, 210);

  // Here are some regions - letters for word "FOX"
  FXRegion letter_F, letter_O, letter_X;

  // construct region - letter 'F'
  FXPoint poly_letter[10];
  poly_letter[0].x = 0;  poly_letter[0].y = 0;
  poly_letter[1].x = 45; poly_letter[1].y = 0;
  poly_letter[2].x = 45; poly_letter[2].y = 15;
  poly_letter[3].x = 15; poly_letter[3].y = 15;
  poly_letter[4].x = 15; poly_letter[4].y = 30;
  poly_letter[5].x = 30; poly_letter[5].y = 30;
  poly_letter[6].x = 30; poly_letter[6].y = 45;
  poly_letter[7].x = 15; poly_letter[7].y = 45;
  poly_letter[8].x = 15; poly_letter[8].y = 75;
  poly_letter[9].x = 0;  poly_letter[9].y = 75;
  letter_F.createPolygon(poly_letter, 10);

  // construct region - letter 'O'
  poly_letter[0].x = 15; poly_letter[0].y = 0;
  poly_letter[1].x = 30; poly_letter[1].y = 0;
  poly_letter[2].x = 45; poly_letter[2].y = 15;
  poly_letter[3].x = 45; poly_letter[3].y = 60;
  poly_letter[4].x = 30; poly_letter[4].y = 75;
  poly_letter[5].x = 15; poly_letter[5].y = 75;
  poly_letter[6].x = 0;  poly_letter[6].y = 60;
  poly_letter[7].x = 0;  poly_letter[7].y = 15;
  letter_O.createPolygon(poly_letter, 8);

  // cut internal area of 'O'
  poly_letter[0].x = 22; poly_letter[0].y = 15;
  poly_letter[1].x = 30; poly_letter[1].y = 22;
  poly_letter[2].x = 30; poly_letter[2].y = 53;
  poly_letter[3].x = 22; poly_letter[3].y = 60;
  poly_letter[4].x = 15; poly_letter[4].y = 53;
  poly_letter[5].x = 15; poly_letter[5].y = 22;
  letter_O -= FXRegion().createPolygon(poly_letter, 6);

  // construct region - letter 'X'
  // element '\'
  poly_letter[0].x = 0;  poly_letter[0].y = 0;
  poly_letter[1].x = 15; poly_letter[1].y = 0;
  poly_letter[2].x = 45; poly_letter[2].y = 75;
  poly_letter[3].x = 30; poly_letter[3].y = 75;
  letter_X.createPolygon(poly_letter, 4);

  // element '/'
  poly_letter[0].x = 0;  poly_letter[0].y = 75;
  poly_letter[1].x = 15; poly_letter[1].y = 75;
  poly_letter[2].x = 45; poly_letter[2].y = 0;
  poly_letter[3].x = 30; poly_letter[3].y = 0;
  letter_X += FXRegion().createPolygon(poly_letter, 4);
// also we can try 'XOR' operation (to estimate changes)
//  letter_X ^= FXRegion().createPolygon(poly_letter, 4);


  // now we can make word "FOX"
  FXRegion word_FOX =
     letter_F + letter_O.offset(50,0) + letter_X.offset(100,0);

  FXRegion penguinMask(0, 210, 160, 100);

  dc.setForeground(backcolor);

  // draw inversed word "FOX" (we can see penguins through letters)
  dc.drawRegion(penguinMask - word_FOX.offset(7, 220));
  
  // draw word "FOX" over penguins
  dc.drawRegion(penguinMask.offset(450, 0) * word_FOX.offset(450, 0));

// --- END OF NEW CODE FOR REGION TESTING -------------------------------------------

